Type.registerNamespace('ApracJs.UI');

ApracJs.UI.SqlMonitorAction = function() {
    ApracJs.UI.SqlMonitorAction.initializeBase(this);
}

ApracJs.UI.SqlMonitorAction.prototype = {
    initialize: function() {
        ApracJs.UI.SqlMonitorAction.callBaseMethod(this, 'initialize');

        this._receiveHandler = $createDelegate(this, this._doReceive);

        var form = this.get_form();
        this._panelElement = form.logs.get_element();

        this.doClear();
        this._receive();
    },

    dispose: function() {
        ApracJs.UI.SqlMonitorAction.callBaseMethod(this, 'dispose');
    },

    _test: function() {
        for (var i = 1; i <= 100; i++) {
            var logItem = {};
            logItem.message = "select * from test where id=" + i;
            logItem.startTime = new Date();
            logItem.elapsedMilliseconds = i * 100;
            this._addLog(logItem);
        }
    },

    doClear: function() {
        this._count = 0;
        this._elapsedMillisecondsSum = 0;
        this._panelElement.innerHTML = "";
    },

    _receive: function() {
        window.asyncCall(this._receiveHandler);
    },

    _receive2: function() {
        window.setTimeout(this._receiveHandler, 1000);
    },

    _doReceive: function() {
        $adminService._invoke('Receive', {}, $createDelegate(this, this.logOk), $createDelegate(this, this.logErr));
    },

    logOk: function(result) {
        if (result) {
            for (var i = 0, count = result.length; i < count; i++) {
                this._addLog(result[i]);
            }
        }
        this._receive2();
    },

    logErr: function(error) {
        $debug.traceDump(error);
        this._receive2();
    },

    _addLog: function(logItem) {
        this._count++;
        this._elapsedMillisecondsSum += logItem.elapsedMilliseconds;

        var html = "<span class='index'>" + this._count + "</span><span class='message'>" + logItem + "</span>";
        /*html += "<div align=right style='padding-bottom:10px;'><table border=0 cellspacing=1 cellpadding=1 bgcolor=#dddddd><tr>"
        html += "<td bgcolor=#f4f4f4><font color=#999999>开始时间</font></td><td bgcolor=#ffffff><font color=#999999>" + Date.dateTimeToStr(logItem.startTime) + "</font></td>";
        html += "<td bgcolor=#f4f4f4><font color=#999999>执行费时(ms)</font></td><td bgcolor=#ffffff align=right width=40 nowarp><font color=#999999>" + logItem.executeElapsedMilliseconds.format("n0") + "</font></td>";
        html += "<td bgcolor=#f4f4f4><font color=#999999>记录数</font></td><td bgcolor=#ffffff align=right width=40 nowarp><font color=#999999>" + logItem.rowCount.format("n0") + "</font></td>";
        html += "<td bgcolor=#f4f4f4><font color=#999999>取数据费时(ms)</font></td><td bgcolor=#ffffff align=right width=40 nowarp><font color=#999999>" + logItem.fetchElapsedMilliseconds.format("n0") + "</font></td>";
        html += "<td bgcolor=#f4f4f4><font color=#999999>费时(ms)</font></td><td bgcolor=#ffffff align=right width=40 nowarp><font color=#999999>" + logItem.elapsedMilliseconds.format("n0") + "</font></td>";
        html += "<td bgcolor=#f4f4f4><font color=#999999>一共费时</font></td><td bgcolor=#ffffff align=right width=40 nowarp><font color=#999999>" + this._elapsedMillisecondsSum.format("n0") + "</font></td>";
        html += "</tr></table></div>";*/

        var div = $common.createClassDiv('item');
        div.innerHTML = html;
        this._panelElement.appendChild(div);
        return html;
    }
}
ApracJs.UI.SqlMonitorAction.registerClass('ApracJs.UI.SqlMonitorAction', Sys.UI.PageAction);
